<h1>
code-edit <a href="https://npmjs.org/package/code-edit"><img src="https://img.shields.io/badge/npm-v3.0.0-F00.svg?colorA=000"/></a> <a href="src"><img src="https://img.shields.io/badge/loc-456-FFF.svg?colorA=000"/></a> <a href="https://cdn.jsdelivr.net/npm/code-edit@3.0.0/dist/code-edit.min.js"><img src="https://img.shields.io/badge/brotli-27.1K-333.svg?colorA=000"/></a> <a href="LICENSE"><img src="https://img.shields.io/badge/license-MIT-F0B.svg?colorA=000"/></a>
</h1>

<p></p>

Lightweight code editor Web Component with syntax highlighting

<h4>
<table><tr><td title="Triple click to select and copy paste">
<code>npm i code-edit </code>
</td><td title="Triple click to select and copy paste">
<code>pnpm add code-edit </code>
</td><td title="Triple click to select and copy paste">
<code>yarn add code-edit</code>
</td></tr></table>
</h4>

## Examples

<details id="example$web" title="web" open><summary><span><a href="#example$web">#</a></span>  <code><strong>web</strong></code></summary>  <ul>    <details id="source$web" title="web source code" ><summary><span><a href="#source$web">#</a></span>  <code><strong>view source</strong></code></summary>  <a href="example/web.ts">example/web.ts</a>  <p>

```ts
import 'code-syntax/themes/default.css'
import 'plenty-themes/laser.css'

import { CodeEditElement, languages } from 'code-edit'

languages.js = import('code-syntax/languages/js')
customElements.define('code-edit', CodeEditElement)

const style = document.createElement('style')
style.textContent = /*css*/ `
html,
body {
  margin: 0;
  padding: 0;
  width: 100%;
  height: 100%;
}
body {
  background: #333;
}
pre {
  color: var(--color);
  background: var(--background);
}
code-edit {
  margin: 15px;
  padding: 15px;
  width: 300px;
  height: 100px;
  font-family: monospace;
  resize: both;
}
`
document.head.appendChild(style)

document.body.innerHTML = /*html*/ `
<code-edit id="demo" autoresize autofocus language="js" theme="laser">export interface HTMLCodeEditElement {
  value?: string
  language?: string
  syntax?: SyntaxDefinition | Promise&lt;{ default: SyntaxDefinition }&gt;
  theme?: string
  tabsize?: number
  tabstyle?: 'tabs' | 'spaces'
  comments?: string
}</code-edit>
`
```

</p>
</details></ul></details>

## API

<p>  <details id="CodeEditElement$24" title="Class" ><summary><span><a href="#CodeEditElement$24">#</a></span>  <code><strong>CodeEditElement</strong></code>     &ndash; CodeEdit custom element</summary>  <a href="src/code-edit.tsx#L183">src/code-edit.tsx#L183</a>  <ul>  <p>

```js
import { CodeEditElement } from 'code-edit'
customElements.define('code-edit', CodeEditElement)
```

```html
<code-edit autofocus autoresize language="js" theme="deep"> ... </code-edit>
```

</p>
      <p>  <details id="constructor$25" title="Constructor" ><summary><span><a href="#constructor$25">#</a></span>  <code><strong>constructor</strong></code><em>()</em>    </summary>    <ul>    <p>  <details id="new CodeEditElement$26" title="ConstructorSignature" ><summary><span><a href="#new CodeEditElement$26">#</a></span>  <code><strong>new CodeEditElement</strong></code><em>()</em>    </summary>    <ul><p><a href="#CodeEditElement$24">CodeEditElement</a></p>        </ul></details></p>    </ul></details><details id="CodeSyntax$38" title="Property" ><summary><span><a href="#CodeSyntax$38">#</a></span>  <code><strong>CodeSyntax</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L207">src/code-edit.tsx#L207</a>  <ul><p><span>Component</span>&lt;<span>CodeSyntaxElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="SuperImpose$39" title="Property" ><summary><span><a href="#SuperImpose$39">#</a></span>  <code><strong>SuperImpose</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L208">src/code-edit.tsx#L208</a>  <ul><p><span>Component</span>&lt;<span>SuperImposeElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="TextAreaCode$40" title="Property" ><summary><span><a href="#TextAreaCode$40">#</a></span>  <code><strong>TextAreaCode</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L209">src/code-edit.tsx#L209</a>  <ul><p><span>Component</span>&lt;<span>TextAreaCodeElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="TextShadow$41" title="Property" ><summary><span><a href="#TextShadow$41">#</a></span>  <code><strong>TextShadow</strong></code>    </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p><details id="__type$42" title="Function" ><summary><span><a href="#__type$42">#</a></span>  <em>({ x, y })</em>    </summary>    <ul>    <p>    <details id="props$44" title="Parameter" ><summary><span><a href="#props$44">#</a></span>  <code><strong>props</strong></code>    </summary>    <ul><p>{<p>  <details id="x$46" title="Property" ><summary><span><a href="#x$46">#</a></span>  <code><strong>x</strong></code>    </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p>number</p>        </ul></details><details id="y$47" title="Property" ><summary><span><a href="#y$47">#</a></span>  <code><strong>y</strong></code>    </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p>number</p>        </ul></details></p>}</p>        </ul></details>  <p><strong></strong><em>({ x, y })</em>  &nbsp;=&gt;  <ul><span>VKid</span></ul></p></p>    </ul></details></p>        </ul></details><details id="autoFocus$29" title="Property" ><summary><span><a href="#autoFocus$29">#</a></span>  <code><strong>autoFocus</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>   &ndash; Autofocus to the element when page loads</summary>  <a href="src/code-edit.tsx#L189">src/code-edit.tsx#L189</a>  <ul><p>boolean</p>        </ul></details><details id="autoResize$30" title="Property" ><summary><span><a href="#autoResize$30">#</a></span>  <code><strong>autoResize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>   &ndash; Whether to autoresize to the height of the contents</summary>  <a href="src/code-edit.tsx#L191">src/code-edit.tsx#L191</a>  <ul><p>boolean</p>        </ul></details><details id="caretBlink$73" title="Property" ><summary><span><a href="#caretBlink$73">#</a></span>  <code><strong>caretBlink</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'none'</code></span>  </summary>  <a href="src/code-edit.tsx#L259">src/code-edit.tsx#L259</a>  <ul><p><code>"blink"</code> | <code>"none"</code></p>        </ul></details><details id="caretBlinkTimeout$74" title="Property" ><summary><span><a href="#caretBlinkTimeout$74">#</a></span>  <code><strong>caretBlinkTimeout</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>-1</code></span>  </summary>  <a href="src/code-edit.tsx#L260">src/code-edit.tsx#L260</a>  <ul><p>any</p>        </ul></details><details id="caretIndex$71" title="Property" ><summary><span><a href="#caretIndex$71">#</a></span>  <code><strong>caretIndex</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>0</code></span>  </summary>  <a href="src/code-edit.tsx#L257">src/code-edit.tsx#L257</a>  <ul><p>number</p>        </ul></details><details id="caretShift$72" title="Property" ><summary><span><a href="#caretShift$72">#</a></span>  <code><strong>caretShift</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'none'</code></span>  </summary>  <a href="src/code-edit.tsx#L258">src/code-edit.tsx#L258</a>  <ul><p><code>"forward"</code> | <code>"backward"</code> | <code>"none"</code></p>        </ul></details><details id="comments$35" title="Property" ><summary><span><a href="#comments$35">#</a></span>  <code><strong>comments</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'// /* */'</code></span>   &ndash; Comment</summary>  <a href="src/code-edit.tsx#L201">src/code-edit.tsx#L201</a>  <ul><p>string</p>        </ul></details><details id="fontSize$28" title="Property" ><summary><span><a href="#fontSize$28">#</a></span>  <code><strong>fontSize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>9.5</code></span>   &ndash; Font size</summary>  <a href="src/code-edit.tsx#L187">src/code-edit.tsx#L187</a>  <ul><p>number</p>        </ul></details><details id="hasFocus$37" title="Property" ><summary><span><a href="#hasFocus$37">#</a></span>  <code><strong>hasFocus</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>  </summary>  <a href="src/code-edit.tsx#L205">src/code-edit.tsx#L205</a>  <ul><p>boolean</p>        </ul></details><details id="height$51" title="Property" ><summary><span><a href="#height$51">#</a></span>  <code><strong>height</strong></code>    </summary>  <a href="src/code-edit.tsx#L218">src/code-edit.tsx#L218</a>  <ul><p><span>HTMLPreElement</span></p>        </ul></details><details id="hoveringMarker$57" title="Property" ><summary><span><a href="#hoveringMarker$57">#</a></span>  <code><strong>hoveringMarker</strong></code>    </summary>  <a href="src/code-edit.tsx#L223">src/code-edit.tsx#L223</a>  <ul><p><code>null</code> | <a href="#Marker$1">Marker</a></p>        </ul></details><details id="language$31" title="Property" ><summary><span><a href="#language$31">#</a></span>  <code><strong>language</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>   &ndash; Language for syntax highlighting</summary>  <a href="src/code-edit.tsx#L193">src/code-edit.tsx#L193</a>  <ul><p>string</p>        </ul></details><details id="layout$50" title="Property" ><summary><span><a href="#layout$50">#</a></span>  <code><strong>layout</strong></code>    </summary>  <a href="src/code-edit.tsx#L217">src/code-edit.tsx#L217</a>  <ul><p><span>SuperImposeElement</span></p>        </ul></details><details id="lenses$58" title="Property" ><summary><span><a href="#lenses$58">#</a></span>  <code><strong>lenses</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>[]</code></span>   &ndash; Lens</summary>  <a href="src/code-edit.tsx#L226">src/code-edit.tsx#L226</a>  <ul><p><a href="#Lens$20">Lens</a>  []</p>        </ul></details><details id="markers$52" title="Property" ><summary><span><a href="#markers$52">#</a></span>  <code><strong>markers</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>[]</code></span>   &ndash; Custom markers</summary>  <a href="src/code-edit.tsx#L221">src/code-edit.tsx#L221</a>  <ul><p><a href="#Marker$1">Marker</a>  []</p>        </ul></details><details id="markersCss$53" title="Property" ><summary><span><a href="#markersCss$53">#</a></span>  <code><strong>markersCss</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L222">src/code-edit.tsx#L222</a>  <ul><p><details id="__type$54" title="Function" ><summary><span><a href="#__type$54">#</a></span>  <em>(selector)</em>    </summary>    <ul>    <p>    <details id="selector$56" title="Parameter" ><summary><span><a href="#selector$56">#</a></span>  <code><strong>selector</strong></code>    </summary>    <ul><p>string</p>        </ul></details>  <p><strong></strong><em>(selector)</em>  &nbsp;=&gt;  <ul>string</ul></p></p>    </ul></details></p>        </ul></details><details id="onInput$64" title="Property" ><summary><span><a href="#onInput$64">#</a></span>  <code><strong>onInput</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L237">src/code-edit.tsx#L237</a>  <ul><p><details id="__type$65" title="Function" ><summary><span><a href="#__type$65">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onScroll$67" title="Property" ><summary><span><a href="#onScroll$67">#</a></span>  <code><strong>onScroll</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L243">src/code-edit.tsx#L243</a>  <ul><p><details id="__type$68" title="Function" ><summary><span><a href="#__type$68">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onWheel$70" title="Property" ><summary><span><a href="#onWheel$70">#</a></span>  <code><strong>onWheel</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L247">src/code-edit.tsx#L247</a>  <ul><p><span>EventHandler</span>&lt;<span>SuperImposeElement</span>, <span>WheelEvent</span>&gt;</p>        </ul></details><details id="onmounted$90" title="Property" ><summary><span><a href="#onmounted$90">#</a></span>  <code><strong>onmounted</strong></code>    </summary>    <ul><p><span>EventHandler</span>&lt;<a href="#CodeEditElement$24">CodeEditElement</a>, <span>CustomEvent</span>&lt;any&gt;&gt;</p>        </ul></details><details id="onunmounted$91" title="Property" ><summary><span><a href="#onunmounted$91">#</a></span>  <code><strong>onunmounted</strong></code>    </summary>    <ul><p><span>EventHandler</span>&lt;<a href="#CodeEditElement$24">CodeEditElement</a>, <span>CustomEvent</span>&lt;any&gt;&gt;</p>        </ul></details><details id="root$59" title="Property" ><summary><span><a href="#root$59">#</a></span>  <code><strong>root</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L228">src/code-edit.tsx#L228</a>  <ul><p><span>ShadowRoot</span></p>        </ul></details><details id="syntax$48" title="Property" ><summary><span><a href="#syntax$48">#</a></span>  <code><strong>syntax</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>{}</code></span>   &ndash; Passing a syntax definition regexp manually</summary>  <a href="src/code-edit.tsx#L214">src/code-edit.tsx#L214</a>  <ul><p><span>SyntaxOrImport</span></p>        </ul></details><details id="tabSize$33" title="Property" ><summary><span><a href="#tabSize$33">#</a></span>  <code><strong>tabSize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>2</code></span>   &ndash; Tab size</summary>  <a href="src/code-edit.tsx#L197">src/code-edit.tsx#L197</a>  <ul><p>number</p>        </ul></details><details id="tabStyle$34" title="Property" ><summary><span><a href="#tabStyle$34">#</a></span>  <code><strong>tabStyle</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'spaces'</code></span>   &ndash; Tab style</summary>  <a href="src/code-edit.tsx#L199">src/code-edit.tsx#L199</a>  <ul><p><code>"spaces"</code> | <code>"tabs"</code></p>        </ul></details><details id="textShadow$36" title="Property" ><summary><span><a href="#textShadow$36">#</a></span>  <code><strong>textShadow</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>   &ndash; Shadow</summary>  <a href="src/code-edit.tsx#L203">src/code-edit.tsx#L203</a>  <ul><p>boolean</p>        </ul></details><details id="textarea$49" title="Property" ><summary><span><a href="#textarea$49">#</a></span>  <code><strong>textarea</strong></code>    </summary>  <a href="src/code-edit.tsx#L216">src/code-edit.tsx#L216</a>  <ul><p><span>TextAreaCodeElement</span></p>        </ul></details><details id="theme$32" title="Property" ><summary><span><a href="#theme$32">#</a></span>  <code><strong>theme</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>   &ndash; Theme to use</summary>  <a href="src/code-edit.tsx#L195">src/code-edit.tsx#L195</a>  <ul><p>string</p>        </ul></details><details id="updateCaret$75" title="Property" ><summary><span><a href="#updateCaret$75">#</a></span>  <code><strong>updateCaret</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L262">src/code-edit.tsx#L262</a>  <ul><p><details id="__type$76" title="Function" ><summary><span><a href="#__type$76">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="value$27" title="Property" ><summary><span><a href="#value$27">#</a></span>  <code><strong>value</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>   &ndash; The editor's value</summary>  <a href="src/code-edit.tsx#L185">src/code-edit.tsx#L185</a>  <ul><p>string</p>        </ul></details><details id="scrollLeft$60" title="Accessor" ><summary><span><a href="#scrollLeft$60">#</a></span>  <code><strong>scrollLeft</strong></code>    </summary>  <a href="src/code-edit.tsx#L230">src/code-edit.tsx#L230</a>  <ul>        </ul></details><details id="scrollTop$62" title="Accessor" ><summary><span><a href="#scrollTop$62">#</a></span>  <code><strong>scrollTop</strong></code>    </summary>  <a href="src/code-edit.tsx#L233">src/code-edit.tsx#L233</a>  <ul>        </ul></details><details id="mounted$78" title="Method" ><summary><span><a href="#mounted$78">#</a></span>  <code><strong>mounted</strong></code><em>($)</em>    </summary>  <a href="src/code-edit.tsx#L279">src/code-edit.tsx#L279</a>  <ul>    <p>    <details id="$$80" title="Parameter" ><summary><span><a href="#$$80">#</a></span>  <code><strong>$</strong></code>    </summary>    <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$24">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$24">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$84" title="Parameter" ><summary><span><a href="#ctor$84">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$83">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$83">T</a>&gt;</ul></p>  <details id="ctx$88" title="Parameter" ><summary><span><a href="#ctx$88">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$87">T</a> | <span>Class</span>&lt;<a href="#T$87">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$87">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {}, <code>"transition"</code>&gt;&gt;</p>        </ul></details>  <p><strong>mounted</strong><em>($)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p></ul></details><details id="Lens$20" title="TypeAlias" ><summary><span><a href="#Lens$20">#</a></span>  <code><strong>Lens</strong></code>    </summary>  <a href="src/code-edit.tsx#L37">src/code-edit.tsx#L37</a>  <ul><p>{<p>  <details id="line$22" title="Property" ><summary><span><a href="#line$22">#</a></span>  <code><strong>line</strong></code>    </summary>  <a href="src/code-edit.tsx#L38">src/code-edit.tsx#L38</a>  <ul><p>number</p>        </ul></details><details id="message$23" title="Property" ><summary><span><a href="#message$23">#</a></span>  <code><strong>message</strong></code>    </summary>  <a href="src/code-edit.tsx#L39">src/code-edit.tsx#L39</a>  <ul><p>string</p>        </ul></details></p>}</p>        </ul></details><details id="Marker$1" title="TypeAlias" ><summary><span><a href="#Marker$1">#</a></span>  <code><strong>Marker</strong></code>    </summary>  <a href="src/code-edit.tsx#L23">src/code-edit.tsx#L23</a>  <ul><p>{<p>  <details id="class$7" title="Property" ><summary><span><a href="#class$7">#</a></span>  <code><strong>class</strong></code>    </summary>  <a href="src/code-edit.tsx#L28">src/code-edit.tsx#L28</a>  <ul><p>string</p>        </ul></details><details id="el$8" title="Property" ><summary><span><a href="#el$8">#</a></span>  <code><strong>el</strong></code>    </summary>  <a href="src/code-edit.tsx#L29">src/code-edit.tsx#L29</a>  <ul><p><span>HTMLSpanElement</span></p>        </ul></details><details id="index$4" title="Property" ><summary><span><a href="#index$4">#</a></span>  <code><strong>index</strong></code>    </summary>  <a href="src/code-edit.tsx#L25">src/code-edit.tsx#L25</a>  <ul><p>number</p>        </ul></details><details id="key$3" title="Property" ><summary><span><a href="#key$3">#</a></span>  <code><strong>key</strong></code>    </summary>  <a href="src/code-edit.tsx#L24">src/code-edit.tsx#L24</a>  <ul><p>string</p>        </ul></details><details id="onwheel$19" title="Property" ><summary><span><a href="#onwheel$19">#</a></span>  <code><strong>onwheel</strong></code>    </summary>  <a href="src/code-edit.tsx#L34">src/code-edit.tsx#L34</a>  <ul><p><span>$.EventHandler</span>&lt;any, <span>WheelEvent</span>&gt;</p>        </ul></details><details id="rect$9" title="Property" ><summary><span><a href="#rect$9">#</a></span>  <code><strong>rect</strong></code>    </summary>  <a href="src/code-edit.tsx#L30">src/code-edit.tsx#L30</a>  <ul><p><span>DOMRect</span></p>        </ul></details><details id="size$5" title="Property" ><summary><span><a href="#size$5">#</a></span>  <code><strong>size</strong></code>    </summary>  <a href="src/code-edit.tsx#L26">src/code-edit.tsx#L26</a>  <ul><p>number</p>        </ul></details><details id="source$6" title="Property" ><summary><span><a href="#source$6">#</a></span>  <code><strong>source</strong></code>    </summary>  <a href="src/code-edit.tsx#L27">src/code-edit.tsx#L27</a>  <ul><p>string</p>        </ul></details><details id="oncreate$10" title="Method" ><summary><span><a href="#oncreate$10">#</a></span>  <code><strong>oncreate</strong></code><em>(el)</em>    </summary>  <a href="src/code-edit.tsx#L31">src/code-edit.tsx#L31</a>  <ul>    <p>    <details id="el$12" title="Parameter" ><summary><span><a href="#el$12">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong>oncreate</strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="onenter$13" title="Method" ><summary><span><a href="#onenter$13">#</a></span>  <code><strong>onenter</strong></code><em>(el)</em>    </summary>  <a href="src/code-edit.tsx#L32">src/code-edit.tsx#L32</a>  <ul>    <p>    <details id="el$15" title="Parameter" ><summary><span><a href="#el$15">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong>onenter</strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="onleave$16" title="Method" ><summary><span><a href="#onleave$16">#</a></span>  <code><strong>onleave</strong></code><em>(el)</em>    </summary>  <a href="src/code-edit.tsx#L33">src/code-edit.tsx#L33</a>  <ul>    <p>    <details id="el$18" title="Parameter" ><summary><span><a href="#el$18">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong>onleave</strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>}</p>        </ul></details></p>

## Credits

- [code-syntax](https://npmjs.org/package/code-syntax) by [stagas](https://github.com/stagas) &ndash; Code syntax highlight Web Component
- [get-element-offset](https://npmjs.org/package/get-element-offset) by [stagas](https://github.com/stagas) &ndash; Get accurate DOM element offset.
- [relative-mouse](https://npmjs.org/package/relative-mouse) by [stagas](https://github.com/stagas) &ndash; Get mouse position relative to a DOM element.
- [sigl](https://npmjs.org/package/sigl) by [stagas](https://github.com/stagas) &ndash; Web framework
- [super-impose](https://npmjs.org/package/super-impose) by [stagas](https://github.com/stagas) &ndash; Web Component that super imposes one child over another to the same scroll position
- [textarea-code](https://npmjs.org/package/textarea-code) by [stagas](https://github.com/stagas) &ndash; Web Component that extends a textarea element with code editor behavior.

## Contributing

[Fork](https://github.com/stagas/code-edit/fork) or [edit](https://github.dev/stagas/code-edit) and submit a PR.

All contributions are welcome!

## License

<a href="LICENSE">MIT</a> &copy; 2022 [stagas](https://github.com/stagas)
